### :warning: Development for this project has moved to a [new repository on GitHub](https://github.com/ccao-data/lightsnip) :warning:

<!-- README.md is generated from README.Rmd. Please edit that file -->

# Lightsnip package <a href='https://gitlab.com/ccao-data-science---modeling/packages/lightsnip'><img src='man/figures/logo.png' align="right" height="139" /></a>

Lightsnip is a hard fork of
[curso-r/treesnip](https://github.com/curso-r/treesnip). It adds
LightGBM bindings for parsnip and enables more advanced LightGBM
features, such as early stopping. It is not intended for general use,
only as a dependency for CCAO regression models.

For detailed documentation on included functions, [**visit the full
reference
list**](https://ccao-data-science---modeling.gitlab.io/packages/lightsnip/reference/).

## Installation

You can install the released version of `lightsnip` directly from GitLab
by running the following R command after installing
[remotes](https://github.com/r-lib/remotes):

``` r
remotes::install_gitlab("ccao-data-science---modeling/packages/lightsnip")
```

Occasionally, when using brand-new or source versions of packages,
installation [on Windows will fail with the following
error](https://github.com/rstudio/renv/issues/162):

    DLL 'package_name' not found: maybe not installed for this architecture?

If this happens, try using the following installation command:

``` r
remotes::install_gitlab(
  repo = "ccao-data-science---modeling/packages/lightsnip",
  INSTALL_opts = "--no-multiarch"
)
```

## Differences compared to [treesnip](https://github.com/curso-r/treesnip)

- Removed support for `tree` and `catboost` (LightGBM only)
- Removed classification support for LightGBM (regression only)
- Removed treesnip caps and warnings on `max_depth`, other parameters
- Removed vignettes and samples
- Remap parameters to engine args instead of parsnip model args
- Added LightGBM-specific hyperparameter functions
- Added LightGBM-specific save/load helpers
- Added recipe/fit cleaning helpers
- Force user to specify categorical columns by name, does *not*
  implicitly convert factors to categoricals
- Added early stopping from xgboost
- Added more unit tests
- Fixed a number of bugs

## Basic usage with Tidymodels

Here is a quick example using `lightsnip` with a Tidymodels
cross-validation workflow:

``` r
library(dplyr)
library(lightgbm)
library(lightsnip)
library(tidymodels)

# Create a dataset for training
mtcars_train <- mtcars %>%
  dplyr::slice(1:28) %>%
  sample_n(size = 500, replace = TRUE) %>%
  mutate(cyl = as.factor(cyl), vs = as.factor(vs))

# Create a test set
mtcars_test <- mtcars %>%
  dplyr::slice(29:32) %>%
  mutate(cyl = as.factor(cyl), vs = as.factor(vs))

# Recipe to convert factors to categorical integers
rec <- recipe(mpg ~ ., mtcars_train) %>%
  step_integer(all_nominal(), zero_based = TRUE)

# Split data into V-folds
resamples <- rsample::vfold_cv(mtcars_train, v = 2)

# Create a model specification. LightGBM-specific parameters are passed to
# set_engine, NOT to boost_tree
model <- parsnip::boost_tree(
  trees = tune::tune()
) %>%
  parsnip::set_engine(
    engine = "lightgbm",
    verbose = -1,
    learning_rate = tune::tune(),
    min_gain_to_split = tune::tune(),
    feature_fraction = tune::tune(),
    min_data_in_leaf = tune::tune(),
    max_depth = tune::tune()
  )

# Run grid search
search <- tune::tune_grid(
  parsnip::set_mode(model, "regression"),
  preprocessor = rec,
  resamples = resamples,
  param_info = model %>%
    hardhat::extract_parameter_set_dials() %>%
    stats::update(
      learning_rate = learning_rate(),
      min_gain_to_split = min_gain_to_split(),
      feature_fraction = feature_fraction(),
      min_data_in_leaf = min_data_in_leaf(c(1L, 2L)),
      max_depth = max_depth(c(3L, 6L))
    ),
  grid = 2,
  metrics = yardstick::metric_set(yardstick::rmse)
)

# Finalize model
final <- model %>%
  tune::finalize_model(tune::select_best(search)) %>%
  parsnip::set_mode("regression") %>%
  parsnip::fit(mpg ~ ., bake(prep(rec), mtcars_train))

# Predict on test set
mtcars_test %>%
  mutate(pred = predict(final, bake(prep(rec), .))$.pred) %>%
  select(mpg, pred) %>%
  knitr::kable(digits = 2)
```

|                |  mpg |  pred |
|:---------------|-----:|------:|
| Ford Pantera L | 15.8 | 18.26 |
| Ferrari Dino   | 19.7 | 20.82 |
| Maserati Bora  | 15.0 | 14.29 |
| Volvo 142E     | 21.4 | 23.63 |
